unit FichierUnt;

interface

uses
    SysUtils, Dialogs, Classes, VariableUnt;

const
     NomDef = 'nouveau.zio';

function OuvrirFichier(Nom : TFileName;var mrec : TMonRecord):boolean;
function EnregistreFichier(Nom : TFileName;mrec : TMonRecord):boolean;
function ExtentionFichier(NomFichier : string; Ext :string):string;

implementation

function OuvrirFichier(Nom : TFileName;var mrec : TMonRecord) : boolean;
var
   F : TFileStream;
   i : integer;
begin
    // Ouvre un fichier test
    F := nil;
    try
      F := TFileStream.Create(Nom, fmOpenRead or fmShareDenyWrite);
      F.Position := 0; // Dbut du flux
      if (pos('.zio',ExtractFileName(Nom))>0) then
      begin
         // Lecture du fichier
         while (F.position < F.Size) do
         begin
            with mrec do
            begin
               // Lit la valeur et dplace la position en cours
               F.ReadBuffer(entier, SizeOf(integer));
               F.ReadBuffer(reel, SizeOf(Double));
               F.ReadBuffer(i, SizeOf(integer));
               enum := TEnumTest(i);
               F.ReadBuffer(chainelimit, SizeOf(Chainelimit));
               F.ReadBuffer(i, SizeOf(i));
               // Allocation d'assez d'espace dans la chaine pour la lecture
               SetLength(chaine, i);
               F.ReadBuffer(chaine[1], i);
            end;
         end;
         Result := true;
      end
      else
      begin
         MessageDlg('Erreur ce n''est pas un fichier test.', mtError, [mbOk], 0);
         Result := false;
      end;
      F.Free;
    except
      on EInOutError do
      begin
        Result := False;
        F.Free;
        MessageDlg('Erreur d''E-S fichier.', mtError, [mbOk], 0);
      end;
      on EReadError do
      begin
         Result := False;
         F.Free;
         MessageDlg('Erreur de lecture sur le fichier.', mtError, [mbOk], 0);
      end;
      else
      begin
         Result := False;
         F.Free;
         MessageDlg('Erreur sur le fichier.', mtError, [mbOk], 0);
      end;
    end; // try
end;

function EnregistreFichier(Nom : TFileName;mrec : TMonRecord):boolean;
var
   F: TFileStream;
   Filetmp : TFileName;
   Chem_tmp, Nom_tmp : string;
   i : integer;
begin
   // Enregistrement d'un fichier
   Chem_tmp := ExtractFilePath(Nom);
   Nom_tmp := '~temp.zio';
   Filetmp := TFileName(Chem_tmp+'\'+Nom_tmp);
   F := nil;
   try
      DeleteFile(Filetmp);
      F := TFileStream.Create(Filetmp, fmCreate or fmShareExclusive);
      F.Position := 0; // Dbut du flux
      // Ecriture du fichier
      with mrec do
      begin
         F.WriteBuffer(entier, SizeOf(integer));
         F.WriteBuffer(reel, SizeOf( Double));
         i := Ord(enum);
         F.WriteBuffer(i, SizeOf(integer));
         F.WriteBuffer(chainelimit, SizeOf(chainelimit));
         i := Length(chaine);
         F.WriteBuffer(i, SizeOf(i));
         F.WriteBuffer(chaine[1], i);
      end;
      F.Free;
      // detruit Nom et renome temp.zio en Nom
      DeleteFile(Nom);
      if RenameFile(Filetmp, ExtractFileName(Nom)) then
          Result := true
      else
          Result := false;
  except
      on EInOutError do
      begin
        Result := False;
        F.Free;
        MessageDlg('Erreur d''E-S fichier : Fichier non enregistr.', mtError, [mbOk], 0);
      end;
      on EWriteError do
      begin
         Result := False;
         F.Free;
         MessageDlg('Erreur d''ecriture dans le fichier. Fichier non enregistr', mtError, [mbOk], 0);
      end;
      else
      begin
         Result := False;
         F.Free;
         MessageDlg('Erreur sur le fichier. Fichier non enregistr.', mtError, [mbOk], 0);
      end;
  end; // try
end;

function ExtentionFichier(NomFichier : string; Ext : string):string;
begin
   if Pos(AnsiUpperCase(Ext), AnsiUpperCase(NomFichier))=0 then
      Result := NomFichier + Ext
   else
      Result := NomFichier;
end;

end.
