unit PrincipalFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, StdCtrls, VariableUnt;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    btInit: TButton;
    btCreate: TButton;
    btOuvrir: TButton;
    btEnregistrer: TButton;
    btDefiler: TButton;
    lbNumCour: TLabel;
    StringGrid1: TStringGrid;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    procedure FormCreate(Sender: TObject);
    procedure btInitClick(Sender: TObject);
    procedure btCreateClick(Sender: TObject);
    procedure btOuvrirClick(Sender: TObject);
    procedure btEnregistrerClick(Sender: TObject);
  private
    { Dclarations prives }
    procedure affiche_ligne();
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;
  MonRecord : TMonRecord;

implementation

uses
    FichierUnt;

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
   // Init
   // initialise la srie
   randomize; // Necessaire pour les nombre altoire
   with StringGrid1 do
   begin
      Cells[0,0] := 'Type';
      Cells[1,0] := 'Valeur';
      Cells[0,1] := 'integer';
      Cells[0,2] := 'Double';
      Cells[0,3] := 'enum';
      Cells[0,4] := 'string limit';
      Cells[0,5] := 'string';
   end;
   lbNumCour.Caption := '0';
end;

procedure TForm1.affiche_ligne();
begin
   with StringGrid1, MonRecord do
   begin
      Cells[1,1] := IntToStr(entier);
      Cells[1,2] := FloatToStr(reel);
      Cells[1,3] := IntToStr(Ord(enum));
      Cells[1,4] := chainelimit;
      Cells[1,5] := chaine;
   end;
end;

procedure TForm1.btInitClick(Sender: TObject);
begin
   // initialise
   MonRecord.entier := 0;
   MonRecord.reel := 0;
   MonRecord.enum := etPos1;
   MonRecord.chaineLimit := '';
   MonRecord.chaine := '';
   affiche_ligne();
   lbNumCour.Caption := '0';
end;

procedure TForm1.btCreateClick(Sender: TObject);
begin
   // Creer des valeurs bidon
   MonRecord.entier := trunc(random(100));
   MonRecord.reel := (-1+random(3))*(random(45663)+0.0001*random(2315));
   MonRecord.enum := TEnumTest(random(4));
   MonRecord.chaineLimit := 'text : abcdefghijklmnopqrstuvwxyz';
   MonRecord.chaine := 'text : 123456789zyxwvutsrqponmlkjihgfedcba';
   lbNumCour.Caption := '0';
   affiche_ligne();
end;

procedure TForm1.btOuvrirClick(Sender: TObject);
begin
   // ouvrir un fichier test
   OpenDialog1.Filter := 'Fichier test (*.zio)|*.ZIO|';
   OpenDialog1.InitialDir := GetCurrentDir;
   if OpenDialog1.Execute then
   begin
      if OuvrirFichier(OpenDialog1.FileName, MonRecord) then
      begin
         lbnumcour.Caption := '0';
         ShowMessage('Chaine : '+MonRecord.chaine);
         affiche_ligne();
      end;
   end;
end;

procedure TForm1.btEnregistrerClick(Sender: TObject);
var
   NFichier : TFileName;
   OkEnr, NoEnr : boolean;
begin
   // Enregistrer sous
   NoEnr := True;
   SaveDialog1.Filter := 'Fichier Test (*.zio)|*.ZIO|';
   SaveDialog1.InitialDir := GetCurrentDir;
   SaveDialog1.FileName := TFileName(NomDef);
   if SaveDialog1.Execute then
   begin
      // Au cas o mais dj mis avec DefautExt
      NFichier := SaveDialog1.FileName;
      SetCurrentDir(ExtractFileDir(SaveDialog1.FileName));
      if FileExists(NFichier) then
      begin
         if MessageDlg('Le fichier existe, le remplacer ?',mtConfirmation,[mbYes,mbNo],0) = mrYes then
            OkEnr := True
         else
            OkEnr := False;
      end
      else
         OkEnr := True;

      if OkEnr then
      begin
         NoEnr := False;
         NFichier := ExtentionFichier(NFichier, '.zio');
         if EnregistreFichier(NFichier, MonRecord) then
            MessageDlg('Le fichier a t enregistr.',mtInformation,[mbOk],0)
         else
            NoEnr := True;
      end;
   end;

   if NoEnr then
      MessageDlg('Le fichier n''a pas t enregistr.',mtError,[mbOk],0);
end;

end.
